Name: qmail
Version: 1.03+patches
Release: 11
Group: Networking/Daemons
URL: http://www.qmail.org/
Copyright: Check with djb@koobera.math.uic.edu
Packager: Bruce Guenter <bruceg@em.ca>
Source0: ftp://koobera.math.uic.edu/pub/software/qmail-1.03.tar.gz
Source1: qmail-rhinit.tar.gz
Source2: dot.qmail-msglog
Source3: syncdir.c
Source4: cron.hourly
Patch0: qmail-1.03-msglog.patch
Patch1: qmail-1.03-condredirect.patch
Patch2: qmail-1.03-showctl.patch
Patch3: qmail-1.03-bind-interface.patch
Patch4: http://www.qmail.org/big-todo.103.patch
Patch5: qmail-1.03-install-path-big-todo.patch
Patch6: qmail-1.03-autouidgid.patch
Patch7: qmail-1.03-syncdir.patch
Patch8: qmail-1.03-pop3d-stat.patch
Patch9: qmail-1.03-queuevar.patch
Patch10: qmail-1.03-big-dns.patch
Patch11: qmail-1.03-big-qstat.patch
Patch12: big-concurrency.patch
Summary: Qmail Mail Transfer Agent
Provides: MTA
Provides: smtpdaemon
Conflicts: sendmail
Conflicts: qmail-cyclog
Obsoletes: qmail-utils
BuildRoot: /tmp/qmail-root
Requires: chkconfig
Requires: initscripts
Requires: net-tools
Requires: sh-utils
Requires: shadow-utils
Requires: supervise-scripts >= 2.2

%description
Qmail is a small, fast, secure replacement for the sendmail package,
which is the program that actually receives, routes, and delivers
electronic mail.  *** Note: Be sure and read the documentation as there
are some small but very significant differences between sendmail and
qmail and the programs that interact with them.

The source for this RPM can be found at:
	http://em.ca/~bruceg/qmail+patches/

%package pop3d
Group: Networking/Daemons
Summary: POP3 server support for qmail
Provides: pop3daemon
Requires: chkconfig
Requires: sh-utils
Requires: supervise-scripts >= 2.0
Requires: ucspi-tcp >= 0.84-1
%description pop3d
Support files for running the qmail POP3 server.

%package qmtpd
Group: Networking/Daemons
Summary: QMTP server support for qmail
Provides: qmtpdaemon
Requires: qmail
Requires: chkconfig
Requires: sh-utils
Requires: supervise-scripts >= 2.0
Requires: ucspi-tcp >= 0.84-1
%description qmtpd
Support files for running the qmail QMTP server.

%package smtpd
Group: Networking/Daemons
Summary: SMTP server support for qmail
Requires: qmail
Requires: chkconfig
Requires: sh-utils
Requires: supervise-scripts >= 2.0
Requires: ucspi-tcp >= 0.84-1
%description smtpd
Support files for running the qmail SMTP server.
RBL blocking is supported if the optional rblsmtpd package is installed.

%package qmqpd
Group: Networking/Daemons
Summary: QMQP server support for qmail
Provides: qmqpdaemon
Requires: qmail
Requires: chkconfig
Requires: sh-utils
Requires: supervise-scripts >= 2.0
Requires: ucspi-tcp >= 0.84-1
%description qmqpd
Support files for running the qmail QMQP server.

%prep
%setup -n qmail-1.03
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1

echo "gcc $RPM_OPT_FLAGS" >conf-cc
echo "gcc -s $RPM_OPT_FLAGS" >conf-ld
fds=`ulimit -n`
let spawnlimit='(fds-6)/2'
echo $spawnlimit >conf-spawn

tar -xzf $RPM_SOURCE_DIR/qmail-rhinit.tar.gz

for source in cron.hourly dot.qmail-msglog syncdir.c; do
	cp $RPM_SOURCE_DIR/$source .
done

%build

make compile makelib
./compile syncdir.c
./makelib libsyncdir.a syncdir.o
make it man

pushd qmail-rhinit
  make "CFLAGS=$RPM_OPT_FLAGS" "LDFLAGS=-s" all
popd

%install
export PATH="/sbin:/usr/sbin:/bin:/usr/bin"
add_user() { useradd -d "$3" -g "$2" -M -r -s /bin/true "$1" || true; }
add_group() { groupadd -r "$1" || true; }
install_file() {
	source="$1"
	dest="$2"
	shift 2
	install "$@" "$source" $RPM_BUILD_ROOT/"$dest"
}

add_group qmail
add_group nofiles

add_user alias  nofiles /etc/qmail/alias
add_user qmaild nofiles /var/qmail
add_user qmaill nofiles /var/qmail
add_user qmailp nofiles /var/qmail
add_user qmailq qmail   /var/qmail
add_user qmailr qmail   /var/qmail
add_user qmails qmail   /var/qmail
add_user qmaillog qmail /var/log

/bin/rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
pushd $RPM_BUILD_ROOT
  install -d etc/cron.hourly
  install -d -o alias -g qmail etc/qmail/alias
  install -d -o root -g qmail etc/qmail
  install -d -g qmail etc/qmail/control
  install -d -g qmail etc/qmail/owners
  install -d -g qmail etc/qmail/users
  install -d etc/tcpcontrol
  install -d usr/bin
  install -d usr/lib
  install -d usr/man
  install -d usr/sbin
  install -d -g qmail var/qmail
  #install -d -o qmaillog -g qmail var/log/{qmail,qmtpd,smtpd,pop3d,qmqpd}

  ln -s ../../etc/qmail/alias var/qmail/alias
  ln -s ../../etc/qmail/control var/qmail/control
  ln -s ../../etc/qmail/owners var/qmail/owners
  ln -s ../../etc/qmail/users var/qmail/users
  ln -s ../../usr/bin var/qmail/bin
  ln -s ../../usr/man var/qmail/man
popd

# Build the user and group files, required for qmail-hier
./make-owners .
# INSTALL IT
./install $RPM_BUILD_ROOT/var/qmail
# CHECK IT
./instcheck $RPM_BUILD_ROOT/var/qmail

# Remove preformatted man pages
rm -rf $RPM_BUILD_ROOT/var/qmail/man/cat*
rm $RPM_BUILD_ROOT/var/qmail/man

# Fix for sendmail add-ons
pushd $RPM_BUILD_ROOT/usr
  mv bin/sendmail sbin/sendmail
  ln -s ../sbin/sendmail bin/mailq
  ln -s ../sbin/sendmail lib/sendmail
  chown qmails.qmail bin/qmail-qread
  chmod ug+s,go-r bin/qmail-qread
popd

# Install some extra configuration programs
install ipmeprint $RPM_BUILD_ROOT/usr/bin

pushd qmail-rhinit
  make PREFIX=$RPM_BUILD_ROOT install
popd

# Install extra shell scripts
install_file cron.hourly etc/cron.hourly/qmail -m 755

install_file dot.qmail-msglog etc/qmail/alias/.qmail-msglog

pushd $RPM_BUILD_ROOT/etc/qmail/alias
  echo '&root' >.qmail-postmaster
  echo '&root' >.qmail-mailer-daemon
  touch .qmail-root
  chmod 644 .qmail*
popd

pushd $RPM_BUILD_ROOT/etc/qmail/control
  touch defaultdomain locals me plusdomain rcpthosts
  chmod 644 defaultdomain locals me plusdomain rcpthosts
popd

pushd $RPM_BUILD_ROOT/etc/qmail/users
  touch append assign cdb include exclude mailnames subusers
  chmod 644 *
popd

$RPM_BUILD_ROOT/usr/bin/make-owners $RPM_BUILD_ROOT/etc/qmail

cat <<EOFaliasempty >$RPM_BUILD_ROOT/etc/qmail/control/aliasempty
|dot-forward .forward
|preline procmail
EOFaliasempty

# rebuild the sym-links under /var/qmail
pushd $RPM_BUILD_ROOT/var/qmail
  rm -f alias control users owners bin man
  ln -s /etc/qmail/alias alias
  ln -s /etc/qmail/control control
  ln -s /etc/qmail/owners owners
  ln -s /etc/qmail/users users
  ln -s /usr/bin bin
  ln -s /usr/man man
  rm -rf boot
  rm -rf doc
  ln -s /usr/doc/qmail-$RPM_PACKAGE_VERSION doc
popd

# Build the default tcpcontrol rules & CDBs
pushd $RPM_BUILD_ROOT/etc/tcpcontrol
  echo :allow >pop-3.rules
  echo :deny >qmqp.rules
  echo :allow >qmtp.rules
  echo :allow >smtp.rules
  tcprules pop-3.cdb pop-3.tmp <pop-3.rules
  tcprules qmqp.cdb qmqp.tmp <qmqp.rules
  tcprules qmtp.cdb qmtp.tmp <qmtp.rules
  tcprules smtp.cdb smtp.tmp <smtp.rules
popd

%clean
rm -rf $RPM_BUILD_ROOT

# Pre/Post-install Scripts #####################################################
%pre
PATH="/sbin:/usr/sbin:$PATH" export PATH
add_user() { grep "^$1:" /etc/passwd >/dev/null || useradd -d "$3" -g "$2" -M -r -s /bin/true "$1"; }
add_group() { grep "^$1:" /etc/group >/dev/null || groupadd -r "$1"; }

if [ $1 = 2 ]; then
	# Disable deliveries if upgrading
	test -d /etc/qmail/alias && chmod +t /etc/qmail/alias
	test -d /var/qmail/alias && chmod +t /var/qmail/alias
	test -d /home && chmod +t /home/*
fi

add_group qmail
add_group nofiles

add_user alias  nofiles /etc/qmail/alias
add_user qmaild nofiles /var/qmail
add_user qmaill nofiles /var/qmail
add_user qmailp nofiles /var/qmail
add_user qmailq   qmail /var/qmail
add_user qmailr   qmail /var/qmail
add_user qmails   qmail /var/qmail
add_user qmaillog qmail /var/log

%post
if [ $1 = 2 ]; then
  # Re-enable deliveries on upgrading
  test -d /etc/qmail/alias && chmod -t /etc/qmail/alias
  test -d /var/qmail/alias && chmod -t /var/qmail/alias
  test -d /home && chmod -t /home/*
fi
/usr/bin/qmail-rhconfig
/usr/bin/make-owners /etc/qmail
/sbin/chkconfig --add qmail

%post pop3d
/sbin/chkconfig --add pop3d

%post qmqpd
/sbin/chkconfig --add qmqpd

%post qmtpd
/sbin/chkconfig --add qmtpd

%post smtpd
/sbin/chkconfig --add smtpd
if [ "$1" = 1 ]; then
	cd /etc
	test -e inetd.conf.rpmsave || cp inetd.conf inetd.conf.rpmsave
	sed	-e 's/^smtp[ 	]/#smtp	/' \
		inetd.conf >inetd.conf.new
	mv inetd.conf.new inetd.conf
	echo "inetd may need to be restarted before incoming SMTP connections"
	echo "will work.  Do this by typing '/etc/rc.d/init.d/inet restart'"
fi

%preun
if [ $1 -gt 0 ]; then exit 0; fi

test -x /etc/rc.d/init.d/qmail && /etc/rc.d/init.d/qmail stop

/sbin/chkconfig --del qmail
echo "Removing Qmail user ids..."
userdel alias
userdel qmaild
userdel qmaill
userdel qmailp
userdel qmailq
userdel qmailr
userdel qmails
userdel qmaillog

echo "Removing Qmail group ids..."
groupdel qmail
groupdel nofiles

%preun pop3d
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/pop3d && /etc/rc.d/init.d/pop3d stop
/sbin/chkconfig --del pop3d

%preun qmqpd
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/qmqpd && /etc/rc.d/init.d/qmqpd stop
/sbin/chkconfig --del qmqpd

%preun qmtpd
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/qmtpd && /etc/rc.d/init.d/qmtpd stop
/sbin/chkconfig --del qmtpd

%preun smtpd
if [ $1 -gt 0 ]; then exit 0; fi
test -x /etc/rc.d/init.d/smtpd && /etc/rc.d/init.d/smtpd stop
/sbin/chkconfig --del smtpd

# Files List ###################################################################
%files
%defattr(-,root,qmail)
%config /etc/profile.d/*

%defattr(-,-,qmail)
%config /etc/cron.hourly/qmail
%dir /etc/qmail

%attr(2755, alias, qmail) %dir /etc/qmail/alias/
%attr(-, alias, qmail) %config(noreplace) /etc/qmail/alias/.qmail-*

%dir /etc/qmail/owners
%config /etc/qmail/owners/*

%dir /etc/qmail/users
%ghost %config(missingok,noreplace) /etc/qmail/users/assign
%ghost %config(missingok,noreplace) /etc/qmail/users/cdb
%ghost %config(missingok,noreplace) /etc/qmail/users/include
%config(noreplace) /etc/qmail/users/append
%config(noreplace) /etc/qmail/users/exclude
%config(noreplace) /etc/qmail/users/mailnames
%config(noreplace) /etc/qmail/users/subusers

%dir /etc/qmail/control
%ghost %config(missingok,noreplace) /etc/qmail/control/defaultdomain
%ghost %config(missingok,noreplace) /etc/qmail/control/locals
%ghost %config(missingok,noreplace) /etc/qmail/control/plusdomain
%ghost %config(missingok,noreplace) /etc/qmail/control/rcpthosts
%verify(mode,group,user) %config(noreplace) /etc/qmail/control/aliasempty
%verify(mode,group,user) %config(noreplace) /etc/qmail/control/me

/etc/rc.d/init.d/qmail

%attr(-,root,qmail) %doc BLURB BLURB2 BLURB3 BLURB4 CHANGES FAQ FILES
%attr(-,root,qmail) %doc INSTALL INSTALL.* INTERNALS PIC.* README REMOVE.*
%attr(-,root,qmail) %doc SECURITY SENDMAIL TEST.* THANKS THOUGHTS TODO UPGRADE

/usr/bin/bouncesaying
/usr/bin/condredirect
/usr/bin/datemail
/usr/bin/elq
/usr/bin/except
/usr/bin/forward
/usr/bin/ipmeprint
/usr/bin/maildir2mbox
/usr/bin/maildirmake
/usr/bin/maildirwatch
/usr/bin/mailq
/usr/bin/mailsubj
/usr/bin/make-owners
/usr/bin/pinq
/usr/bin/predate
/usr/bin/preline
/usr/bin/qail
/usr/bin/qbiff
%attr(0711,root,qmail) /usr/bin/qmail-clean
%attr(0711,root,qmail) /usr/bin/qmail-getpw
/usr/bin/qmail-inject
%attr(0711,root,qmail) /usr/bin/qmail-local
%attr(0700,root,qmail) /usr/bin/qmail-lspawn
%attr(0700,root,qmail) /usr/bin/qmail-newmrh
%attr(0700,root,qmail) /usr/bin/qmail-newu
%attr(0711,root,qmail) /usr/bin/qmail-pw2u
#OMIT /usr/bin/qmail-qmqpc
%attr(06711,qmails,qmail) /usr/bin/qmail-qread
/usr/bin/qmail-qstat
%attr(04711,qmailq,qmail) /usr/bin/qmail-queue
%attr(0711,root,qmail) /usr/bin/qmail-remote
/usr/bin/qmail-rhconfig
%attr(0711,root,qmail) /usr/bin/qmail-rspawn
%attr(0711,root,qmail) /usr/bin/qmail-send
/usr/bin/qmail-showctl
%attr(0700,root,qmail) /usr/bin/qmail-start
/usr/bin/qmail-tcpok
/usr/bin/qmail-tcpto
/usr/bin/qreceipt
/usr/bin/qsmhook
%attr(0711,root,qmail) /usr/bin/splogger
/usr/bin/tcp-env

/usr/lib/qmail
/usr/lib/sendmail

/usr/man/man1/bouncesaying.1
/usr/man/man1/condredirect.1
/usr/man/man1/except.1
/usr/man/man1/forward.1
/usr/man/man1/maildir2mbox.1
/usr/man/man1/maildirmake.1
/usr/man/man1/maildirwatch.1
/usr/man/man1/mailsubj.1
/usr/man/man1/preline.1
/usr/man/man1/qbiff.1
/usr/man/man1/qreceipt.1
/usr/man/man1/tcp-env.1
/usr/man/man5/addresses.5
/usr/man/man5/dot-qmail.5
/usr/man/man5/envelopes.5
/usr/man/man5/maildir.5
/usr/man/man5/mbox.5
/usr/man/man5/qmail-control.5
/usr/man/man5/qmail-header.5
/usr/man/man5/qmail-log.5
/usr/man/man5/qmail-users.5
/usr/man/man5/tcp-environ.5
/usr/man/man7/forgeries.7
/usr/man/man7/qmail-limits.7
/usr/man/man7/qmail.7
/usr/man/man8/qmail-clean.8
/usr/man/man8/qmail-command.8
/usr/man/man8/qmail-getpw.8
/usr/man/man8/qmail-init.8
/usr/man/man8/qmail-inject.8
/usr/man/man8/qmail-local.8
/usr/man/man8/qmail-lspawn.8
/usr/man/man8/qmail-newmrh.8
/usr/man/man8/qmail-newu.8
/usr/man/man8/qmail-pw2u.8
#OMIT /usr/man/man8/qmail-qmqpc.8
/usr/man/man8/qmail-qread.8
/usr/man/man8/qmail-qstat.8
/usr/man/man8/qmail-queue.8
/usr/man/man8/qmail-remote.8
/usr/man/man8/qmail-rspawn.8
/usr/man/man8/qmail-send.8
/usr/man/man8/qmail-showctl.8
/usr/man/man8/qmail-start.8
/usr/man/man8/qmail-tcpok.8
/usr/man/man8/qmail-tcpto.8
/usr/man/man8/splogger.8

/usr/sbin/sendmail

%dir /var/service/qmail
%dir /var/service/qmail/log
%config /var/service/qmail/log/run
%config /var/service/qmail/run

/var/qmail

%files pop3d
%defattr(-,root,qmail)
/etc/rc.d/init.d/pop3d
%config(noreplace) /etc/tcpcontrol/pop-3.cdb
%config(noreplace) /etc/tcpcontrol/pop-3.rules
/usr/bin/qmail-pop3d
%attr(700,root,qmail) /usr/bin/qmail-popup
%dir /var/service/pop3d
%dir /var/service/pop3d/log
%config /var/service/pop3d/log/run
%config /var/service/pop3d/run
/usr/man/man8/qmail-pop3d.8
/usr/man/man8/qmail-popup.8

%files qmqpd
%defattr(-,root,qmail)
/etc/rc.d/init.d/qmqpd
%config(noreplace) /etc/tcpcontrol/qmqp.cdb
%config(noreplace) /etc/tcpcontrol/qmqp.rules
/usr/bin/qmail-qmqpd
%dir /var/service/qmqpd
%dir /var/service/qmqpd/log
%config /var/service/qmqpd/log/run
%config /var/service/qmqpd/run
/usr/man/man8/qmail-qmqpd.8

%files qmtpd
%defattr(-,root,qmail)
/etc/rc.d/init.d/qmtpd
%config(noreplace) /etc/tcpcontrol/qmtp.cdb
%config(noreplace) /etc/tcpcontrol/qmtp.rules
/usr/bin/qmail-qmtpd
%dir /var/service/qmtpd
%dir /var/service/qmtpd/log
%config /var/service/qmtpd/log/run
%config /var/service/qmtpd/run
/usr/man/man8/qmail-qmtpd.8

%files smtpd
%defattr(-,root,qmail)
/etc/rc.d/init.d/smtpd
%config(noreplace) /etc/tcpcontrol/smtp.cdb
%config(noreplace) /etc/tcpcontrol/smtp.rules
/usr/bin/qmail-pipe
/usr/bin/qmail-smtpd
%dir /var/service/smtpd
%dir /var/service/smtpd/log
%config /var/service/smtpd/log/run
%config /var/service/smtpd/run
/usr/man/man8/qmail-smtpd.8
